//---------------------------------------------------------------------------
#ifndef TDirCreatorH
#define TDirCreatorH
#include <Classes.hpp>
#include "TDirCreationOptions.h"
class TFileNameList;
//---------------------------------------------------------------------------
class EDirCreationFail : public Exception
{
private:
protected:
public:
	__fastcall EDirCreationFail(AnsiString AMessage);
};
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
class TDirCreator : public TObject
{
public:
	typedef void __fastcall (__closure* TAskLocationEvent)(TObject* ASender,
		AnsiString& ALocation);
private:
	TStrings* FSrcNames;
	AnsiString FFixedPath;
	int FDone;
	TDirCreationOptions FOptions;
	TAskLocationEvent FOnAskLocation;
	void __fastcall Initialize(TStrings* ASrcNames);
	void __fastcall Uninitialize();
	void __fastcall CreateNextDir();
	AnsiString __fastcall GetNextDirName();
	AnsiString __fastcall GetNextSrcName();
	AnsiString __fastcall GetNextPath(AnsiString ASrcName);
	void __fastcall EnsureFixedPath();
	AnsiString __fastcall DoAskLocation();
	__property TStrings* SrcNames = {read=FSrcNames};
	__property AnsiString FixedPath = {read=FFixedPath, write=FFixedPath};
	__property int Done = {read=FDone, write=FDone};
	__property TDirCreationOptions Options = {read=FOptions};
protected:
public:
	__fastcall TDirCreator(TStrings* ASrcNames,
		TDirCreationOptions AOptions);
	virtual __fastcall ~TDirCreator();
	virtual bool __fastcall HasNext() const;
	virtual void __fastcall CreateNext();
	__property TAskLocationEvent OnAskLocation = {read=FOnAskLocation,
		write=FOnAskLocation};
};
//---------------------------------------------------------------------------
#endif

