//---------------------------------------------------------------------------
#ifndef TMainFormH
#define TMainFormH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "TDirData.h"
#include "TOptionsDialog.h"
class TFileNameList;
//---------------------------------------------------------------------------
class TMainForm : public TForm
{
__published:
	void __fastcall ApplicationException(TObject* ASender,
		Exception* AException);
	void __fastcall ApplicationIdle(TObject* ASender, bool& ADone);
	void __fastcall DirCreatorAskLocation(TObject* ASender,
		AnsiString& ALocation);
	void __fastcall FormCloseQuery(TObject* ASender, bool& ACanClose);
	void __fastcall OptionsDialogApply(TObject* ASender,
		TOptionsDialogData AData);
	void __fastcall OptionsDialogCommandAbout(TObject* ASender);
	void __fastcall OptionsDialogCommandHelp(TObject* ASender);
	void __fastcall OptionsDialogDefault(TObject* ASender,
		TOptionsDialogData& AData);
private:
	static AnsiString INFO_ABOUT;
	static AnsiString FILE_PATH;
	static AnsiString FILE_SETTINGS;
	static AnsiString FILE_HELP;
	TDirData* FDirData;
	void __fastcall Initialize();
	void __fastcall Uninitialize();
	void __fastcall LoadSettings();
	void __fastcall SaveSettings();
	void __fastcall ProcessCommandParams();
	void __fastcall ShowOptionsDialog();
	void __fastcall CreateDirectories();
	void __fastcall GetSrcFiles(TStrings* ASrcFiles);
	void __fastcall ShowError(AnsiString AMessage);
	__property TDirData* DirData = {read=FDirData};
protected:
public:
	__fastcall TMainForm(TComponent* AOwner);
	virtual __fastcall ~TMainForm();
};
//---------------------------------------------------------------------------
extern PACKAGE TMainForm* AMainForm;
//---------------------------------------------------------------------------
#endif

