//---------------------------------------------------------------------------
#ifndef TOptionsDialogH
#define TOptionsDialogH
//---------------------------------------------------------------------------
#include <vcl\ExtCtrls.hpp>
#include <vcl\Buttons.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Controls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\Graphics.hpp>
#include <vcl\Classes.hpp>
#include <vcl\SysUtils.hpp>
#include <vcl\Windows.hpp>
#include <vcl\System.hpp>
#include "TDirCreationOptions.h"
//---------------------------------------------------------------------------
struct TOptionsDialogData
{
	TDirCreationOptions DirCreationOptions;
};
//---------------------------------------------------------------------------
class TOptionsDialog : public TForm
{
__published:
	TButton* Button11;
	TButton* Button12;
	TButton* Button13;
	TButton* Button14;
	TButton* Button15;
	TButton* Button16;
	TButton* Button21;
	TCheckBox* CheckBox21;
	TCheckBox* CheckBox22;
	TComboBox* ComboBox21;
	TEdit* Edit21;
	TEdit* Edit22;
	TEdit* Edit23;
	TEdit* Edit24;
	TEdit* Edit25;
	TEdit* Edit26;
	TEdit* Edit27;
	TGroupBox* GroupBox21;
	TLabel* Label21;
	TLabel* Label22;
	TLabel* Label23;
	TLabel* Label24;
	TLabel* Label25;
	TLabel* Label26;
	TLabel* Label27;
	TLabel* Label28;
	TPanel* Panel21;
	TRadioButton* RadioButton21;
	TRadioButton* RadioButton22;
	TRadioButton* RadioButton23;
	TRadioButton* RadioButton24;
	void __fastcall Button13Click(TObject* ASender);
	void __fastcall Button14Click(TObject* ASender);
	void __fastcall Button15Click(TObject* ASender);
	void __fastcall Button16Click(TObject* ASender);
	void __fastcall Button21Click(TObject* ASender);
	void __fastcall CheckBoxClick(TObject* ASender);
	void __fastcall ComboBoxChange(TObject* ASender);
	void __fastcall Edit22Exit(TObject* ASender);
	void __fastcall Edit23Exit(TObject* ASender);
	void __fastcall Edit24Exit(TObject* ASender);
	void __fastcall Edit25Exit(TObject* ASender);
	void __fastcall Edit26Exit(TObject* ASender);
	void __fastcall Edit27Exit(TObject* ASender);
	void __fastcall EditChange(TObject* ASender);
	void __fastcall FormCloseQuery(TObject* ASender, bool& ACanClose);
	void __fastcall FormShow(TObject* ASender);
	void __fastcall RadioButtonClick(TObject* ASender);
public:
	typedef void __fastcall (__closure* TApplyEvent)(TObject* ASender,
		TOptionsDialogData AData);
	typedef void __fastcall (__closure* TDefaultEvent)(TObject* ASender,
		TOptionsDialogData& AData);
private:
	class EInvalidEntry : public Exception
	{
	public:
		__fastcall EInvalidEntry(AnsiString AMessage);
	};
	TOptionsDialogData FData;
	bool FModified;
	TApplyEvent FOnApply;
	TDefaultEvent FOnDefault;
	TNotifyEvent FOnCommandHelp;
	TNotifyEvent FOnCommandAbout;
	TOptionsDialogData __fastcall EntriesToData();
	void __fastcall DataToEntries(TOptionsDialogData AData);
	TDirCreationOptions __fastcall EntriesToDirCreationOptions(bool AStrict);
	void __fastcall DirCreationOptionsToEntries(
		TDirCreationOptions ADirCreationOptions);
	int __fastcall EditToInt(TEdit* AEdit);
	AnsiString __fastcall EditToFileName(TEdit* AEdit);
	void __fastcall SetModified(bool AModified);
	void __fastcall SetOnApply(TApplyEvent AOnApply);
	void __fastcall SetOnDefault(TDefaultEvent AOnDefault);
	void __fastcall SetOnCommandHelp(TNotifyEvent AOnCommandHelp);
	void __fastcall SetOnCommandAbout(TNotifyEvent AOnCommandAbout);
	void __fastcall Change();
	void __fastcall DoApply();
	TOptionsDialogData __fastcall DoDefault();
	void __fastcall DoCommandHelp();
	void __fastcall DoCommandAbout();
	void __fastcall RaiseInvalidEntry(AnsiString AMessage,
		TWinControl* AControl);
	__property TOptionsDialogData Data = {read=FData, write=FData};
	__property bool Modified = {read=FModified, write=SetModified};
protected:
public:
	virtual __fastcall TOptionsDialog(TComponent* AOwner);
	virtual __fastcall ~TOptionsDialog();
	virtual bool __fastcall Execute(TOptionsDialogData& AData);
	__property TApplyEvent OnApply = {read=FOnApply, write=SetOnApply};
	__property TDefaultEvent OnDefault = {read=FOnDefault,
		write=SetOnDefault};
	__property TNotifyEvent OnCommandHelp = {read=FOnCommandHelp,
		write=SetOnCommandHelp};
	__property TNotifyEvent OnCommandAbout = {read=FOnCommandAbout,
		write=SetOnCommandAbout};
};
//---------------------------------------------------------------------------
extern PACKAGE TOptionsDialog* OptionsDialog;
//---------------------------------------------------------------------------
#endif

