//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "SystemUtils.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
// Files
//---------------------------------------------------------------------------
bool __fastcall FileOrDirExists(AnsiString AFileName)
{
	return GetFileAttributes(AFileName.c_str()) != 0xFFFFFFFF;
}
//---------------------------------------------------------------------------
AnsiString __fastcall FullyQualifyFileName(AnsiString AFileName)
{
	AnsiString fileName = ExpandUNCFileName(AFileName);
	if(fileName.Length() == 0) {
		return AnsiString();
	}
	fileName = GetLongFileName(fileName);
	if(fileName.Length() == 0) {
		return AnsiString();
	}
	return fileName;
}
//---------------------------------------------------------------------------
AnsiString __fastcall GetLongFileName(AnsiString AFileName)
{
	if(AFileName.Length() == 0 || AFileName.Length() >= MAX_PATH ||
			AFileName.LastDelimiter("*?") >= 1) {
		return AnsiString();
	}
	TCHAR buffer[MAX_PATH] = {'\0'};
	const DWORD bufferSize = sizeof(buffer) / sizeof(TCHAR);
	const DWORD dataLength = GetLongPathName(AFileName.c_str(), buffer,
		bufferSize);
	if(dataLength == 0 || dataLength >= bufferSize) {
		return AnsiString();
	}
	return AnsiString(buffer);
}
//---------------------------------------------------------------------------
AnsiString __fastcall GetSpecialDir(UINT AId)
{
	TCHAR buffer[MAX_PATH] = {'\0'};
	if(!SHGetSpecialFolderPath(NULL, buffer, AId, false)) {
		return AnsiString();
	}
	return AnsiString(buffer);
}
//---------------------------------------------------------------------------
bool __fastcall IsAbsoluteFileName(AnsiString AFileName)
{
	return ExtractFileDrive(AFileName).Length() > 0;
}
//---------------------------------------------------------------------------
bool __fastcall IsValidFileName(AnsiString ABaseName)
{
	return ABaseName.LastDelimiter("\\/:;*?\"<>|") < 1;
}
//---------------------------------------------------------------------------

