//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "TFileExecutor.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
// class TFileExecutor
//---------------------------------------------------------------------------
// private:
//---------------------------------------------------------------------------
const char* TFileExecutor::VERB_EDIT = "edit";
const char* TFileExecutor::VERB_EXPLORE = "explore";
const char* TFileExecutor::VERB_FIND = "find";
const char* TFileExecutor::VERB_OPEN = "open";
const char* TFileExecutor::VERB_PRINT = "print";
const char* TFileExecutor::VERB_PROPERTIES = "properties";
//---------------------------------------------------------------------------
bool __fastcall TFileExecutor::Execute(AnsiString AVerb,
	AnsiString AFileName, AnsiString AParameters)
{
	bool succeeded = false;
	for(;;) {
		SHELLEXECUTEINFO executeInfo;
		ZeroMemory(&executeInfo, sizeof(SHELLEXECUTEINFO));
		executeInfo.cbSize = sizeof(SHELLEXECUTEINFO);
		executeInfo.fMask = 0;
		if(!ShowError) {
			executeInfo.fMask |= SEE_MASK_FLAG_NO_UI;
		}
		if(lstrcmpi(AVerb.c_str(), VERB_PROPERTIES) == 0) {
			executeInfo.fMask |= SEE_MASK_INVOKEIDLIST;
		}
		executeInfo.hwnd = Parent;
		executeInfo.lpVerb = AVerb.c_str();
		executeInfo.lpFile = AFileName.c_str();
		executeInfo.lpParameters =
			static_cast<const char*>(AParameters.data());
		executeInfo.lpDirectory =
			static_cast<const char*>(Directory.data());
		executeInfo.nShow = ShowCommand;
		if(!ShellExecuteEx(&executeInfo)) {
			break;
		}
		succeeded = true;
		break;
	}
	return succeeded;
}
//---------------------------------------------------------------------------
// protected:
//---------------------------------------------------------------------------
// public:
//---------------------------------------------------------------------------
__fastcall TFileExecutor::TFileExecutor() :
	FParent(NULL),
	FDirectory(),
	FShowCommand(SW_SHOWNORMAL),
	FShowError(true)
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TFileExecutor::~TFileExecutor()
{
	// Do nothing
}
//---------------------------------------------------------------------------
bool __fastcall TFileExecutor::EditFile(AnsiString AFileName,
	AnsiString AParameters)
{
	return Execute(VERB_EDIT, AFileName, AParameters);
}
//---------------------------------------------------------------------------
bool __fastcall TFileExecutor::ExploreFile(AnsiString AFileName,
	AnsiString AParameters)
{
	return Execute(VERB_EXPLORE, AFileName, AParameters);
}
//---------------------------------------------------------------------------
bool __fastcall TFileExecutor::FindFile(AnsiString AFileName,
	AnsiString AParameters)
{
	return Execute(VERB_FIND, AFileName, AParameters);
}
//---------------------------------------------------------------------------
bool __fastcall TFileExecutor::OpenFile(AnsiString AFileName,
	AnsiString AParameters)
{
	return Execute(VERB_OPEN, AFileName, AParameters);
}
//---------------------------------------------------------------------------
bool __fastcall TFileExecutor::PrintFile(AnsiString AFileName,
	AnsiString AParameters)
{
	return Execute(VERB_PRINT, AFileName, AParameters);
}
//---------------------------------------------------------------------------
bool __fastcall TFileExecutor::ShowFileProperties(AnsiString AFileName,
	AnsiString AParameters)
{
	return Execute(VERB_PROPERTIES, AFileName, AParameters);
}
//---------------------------------------------------------------------------

