//---------------------------------------------------------------------------
#ifndef TFileExecutorH
#define TFileExecutorH
#include <Classes.hpp>
//---------------------------------------------------------------------------
class TFileExecutor
{
private:
	static const char* VERB_EDIT;
	static const char* VERB_EXPLORE;
	static const char* VERB_FIND;
	static const char* VERB_OPEN;
	static const char* VERB_PRINT;
	static const char* VERB_PROPERTIES;
	HWND FParent;
	AnsiString FDirectory;
	int FShowCommand;
	bool FShowError;
	__fastcall TFileExecutor(const TFileExecutor& ASrc);
	TFileExecutor& __fastcall operator=(const TFileExecutor& ASrc);
	virtual bool __fastcall Execute(AnsiString AVerb, AnsiString AFileName,
		AnsiString AParameters);
protected:
public:
	__fastcall TFileExecutor();
	virtual __fastcall ~TFileExecutor();
	virtual bool __fastcall EditFile(AnsiString AFileName,
		AnsiString AParameters);
	virtual bool __fastcall ExploreFile(AnsiString AFileName,
		AnsiString AParameters);
	virtual bool __fastcall FindFile(AnsiString AFileName,
		AnsiString AParameters);
	virtual bool __fastcall OpenFile(AnsiString AFileName,
		AnsiString AParameters);
	virtual bool __fastcall PrintFile(AnsiString AFileName,
		AnsiString AParameters);
	virtual bool __fastcall ShowFileProperties(AnsiString AFileName,
		AnsiString AParameters);
	__property HWND Parent = {read=FParent, write=FParent};
	__property AnsiString Directory = {read=FDirectory, write=FDirectory};
	__property int ShowCommand = {read=FShowCommand, write=FShowCommand};
	__property bool ShowError = {read=FShowError, write=FShowError};
};
//---------------------------------------------------------------------------
#endif

