//---------------------------------------------------------------------------
// TMessageDialog Class
// Copyright (C) 2006 Moochos. All rights reserved.
//---------------------------------------------------------------------------
#ifndef TMessageDialogH
#define TMessageDialogH
#include <Classes.hpp>
#include <Dialogs.hpp>
//---------------------------------------------------------------------------
class TMessageDialog
{
public:
	enum
	{
		TYPE_WARNING,
		TYPE_ERROR,
		TYPE_INFORMATION,
		TYPE_QUESTION,
		TYPE_ORIGINAL,
		TYPE_NONE,
	};
	class EMessageDialogError : public Exception
	{
	public:
		__fastcall EMessageDialogError(AnsiString AMessage);
	};
private:
	AnsiString FCaption;
	AnsiString FMessage;
	TStrings* FButtons;
	int FDefault;
	int FCancel;
	int FType;
	TIcon* FIcon;
	static void __fastcall GetControls(TCustomForm* AForm, TList* AControls);
	static void __fastcall EnableCloseButton(TCustomForm* AForm,
		bool AEnabled);
	__fastcall TMessageDialog(const TMessageDialog& ASrc);
	TMessageDialog& __fastcall operator=(const TMessageDialog& ASrc);
	void __fastcall Initialize();
	void __fastcall Uninitialize();
	TForm* __fastcall MakeDialog();
	AnsiString __fastcall GetDialogMessage();
	TMsgDlgType __fastcall GetMsgDlgType();
	TMsgDlgButtons __fastcall GetMsgDlgButtons();
	bool __fastcall CanCancel();
	void __fastcall AddCancelStopper(TForm* ADialog);
	void __fastcall ModifyControls(TForm* ADialog);
	int __fastcall ShowDialog(TForm* ADialog);
protected:
public:
	__fastcall TMessageDialog();
	__fastcall ~TMessageDialog();
	int __fastcall Execute();
	__property AnsiString Caption = {read=FCaption, write=FCaption};
	__property AnsiString Message = {read=FMessage, write=FMessage};
	__property TStrings* Buttons = {read=FButtons};
	__property int Default = {read=FDefault, write=FDefault};
	__property int Cancel = {read=FCancel, write=FCancel};
	__property int Type = {read=FType, write=FType};
	__property TIcon* Icon = {read=FIcon};
};
//---------------------------------------------------------------------------
#endif

