//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "TQuoteIniFile.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
// class TQuoteIniFile : public TMemIniFile
//---------------------------------------------------------------------------
// private:
//---------------------------------------------------------------------------
AnsiString __fastcall TQuoteIniFile::QuoteString(AnsiString AString) const
{
	return AnsiString().sprintf("%c%s%c", QuoteChar, AString.c_str(),
		QuoteChar);
}
//---------------------------------------------------------------------------
AnsiString __fastcall TQuoteIniFile::UnquoteString(AnsiString AString) const
{
	AnsiString newString = AString;
	for(int i = 0; i < 2; i++) {
		if(newString.Length() == 0) {
			break;
		}
		int charIndex = i == 0 ? 1 : newString.Length();
		if(newString.ByteType(charIndex) != mbSingleByte ||
				newString[charIndex] != QuoteChar) {
			break;
		}
		newString.Delete(charIndex, 1);
	}
	return newString;
}
//---------------------------------------------------------------------------
// protected:
//---------------------------------------------------------------------------
// public:
//---------------------------------------------------------------------------
__fastcall TQuoteIniFile::TQuoteIniFile(const AnsiString AFileName) :
	TMemIniFile(AFileName),
	FQuoteChar('\"')
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TQuoteIniFile::~TQuoteIniFile()
{
	// Do nothing
}
//---------------------------------------------------------------------------
AnsiString __fastcall TQuoteIniFile::ReadQuotedString(
	const AnsiString ASection, const AnsiString AIdent,
	const AnsiString ADefault)
{
	return UnquoteString(ReadString(ASection, AIdent,
		QuoteString(ADefault)));
}
//---------------------------------------------------------------------------
void __fastcall TQuoteIniFile::WriteQuotedString(const AnsiString ASection,
	const AnsiString AIdent, const AnsiString AValue)
{
	return WriteString(ASection, AIdent, QuoteString(AValue));
}
//---------------------------------------------------------------------------

